#include <bits/stdc++.h>
using namespace std;
long long n,m, dp [4][1000007],gore[1000007],niz[10000007],pref[10000007];
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m ;
    for (int i=1;i<=n;i++){
        for (int j=1;j<=m;j++){
            cin >> niz[j];
        }
        for (int k=1;k<=m;k++){
            pref[k]=niz[k]+pref[k-1];
        }
        for (int k=1;k<=m;k++){
            dp[2][k]=min(gore[k]+dp[2][k-1], dp[1][k]+pref[k-1]);
        }
        for (int k=1;k<=m;k++){
            gore[k]+=niz[k];
            dp[1][k]=dp[2][k];
        }
    }
    cout << dp[2][m]<<endl;



    return 0;
}